var editor=new ItemList();
editor.cellsize=64;
makeSelector(editor,'blue','white');

editor[0]={piece:new Cap(), label:'Cap'};
editor[1]={piece:new Goal(), label:'Goal'};
editor[2]={piece:new Ungoal(), label:'Ungoal'};
editor[3]={piece:new Piece({color:'white',shape:'square'}), label:'Empty'};

editor[3].piece.type='empty';

for(var n=0;n<editor.length;n++){
	editor[n].onclick=editor.selectcallback;
}

editor.repaint();

var savedOnclick=null;

function enterEditorMode(){
	board.abortSelect();
	savedOnclick=board.onclick;
	board.onclick=editorClick;
}

function leaveEditorMode(){
	board.onclick=savedOnclick;
}

function editorClick(x,y,b){
	if(editor.selected == undefined)return;
	var type=editor[editor.selected].piece.type;

	if(type=='cap'){
		var cap=capAt(x,y);
		if(cap)board.remove(cap);
		else board.place(new Cap(),x,y);
	}
	else if(type=='goal'){
		var goal=goalAt(x,y);
		var ungoal=ungoalAt(x,y);
		if(ungoal)board.remove(ungoal);
		if(goal)board.remove(goal);
		else board.place(new Goal(),x,y);
	}
	else if(type=='ungoal'){
		var goal=goalAt(x,y);
		var ungoal=ungoalAt(x,y);
		if(goal)board.remove(goal);
		if(ungoal)board.remove(ungoal);
		else board.place(new Ungoal(),x,y);
	}
	else if(type=='empty'){
		var empty=emptyAt(x,y);
		if(empty)board.remove(empty);
		else board.place(new Empty(),x,y)
	}
	
	reorderPieces(x,y);
}

function reorderPieces(x,y){
	var empty=emptyAt(x,y);
	var goal=goalAt(x,y);
	var ungoal=ungoalAt(x,y);
	var cap=capAt(x,y);
	
	var pcs=board.pieces(x,y);
	for(var p=0;p<pcs.length;p++){
		board.remove(pcs[p]);
	}

	pcs=[empty,goal,ungoal,cap];
	for(var p=0;p<pcs.length;p++){
		if(pcs[p])board.place(pcs[p],x,y);
	}
}