// Global vars //////////////////////////////
var gamemap=new Map(32,32);
var sidebar=new Sidebar();
var rover=makeRover();
var rocket=makeRocket();

var ignoreClicks=false;
rover.onanimate=function(a){
	ignoreClicks=(a=='start');
}

var status={
	gems:0,
	fuel:5
};

Window.map=gamemap;
Window.sidebar=sidebar;

sidebar[2]={type:'line'};
sidebar[3]={type:'button',
	label:'Use a gem',
	onclick:function(){
		useGem();
	}};

gamemap.place(rover,0,0);
gamemap.place(rocket,1,5);

for(var x=0;x<10;x++)
	gamemap.spaces[x][3]='black';

var gemLocs=[
	pt(2,1),
	pt(4,2),
	pt(8,1),
	pt(10,3),
	pt(7,4),
	pt(3,6)
]

for(g in gemLocs)
	gamemap.place(makeGem(),gemLocs[g].x,gemLocs[g].y);

updateSidebar();
/////////////////////////////////////////////

// Placeholder graphics logic ///////////////
function wallP(p){
	if(!inbounds(p))return true;
	return gamemap.spaces[p.x][p.y]=='black';
}

function rocketP(piece){
	return piece.details=='red';
}

function makeGem(){
	var p=new Piece('green');
	p.type='gem';
	return p;
}

function makeRover(){
	var p=new Piece('black');
	p.type='rover';
	return p;
}

function makeRocket(){
	var p=new Piece('red');
	p.type='rocket';
	return p;
}
/////////////////////////////////////////////

function inbounds(p){
	var x=p.x;
	var y=p.y;
	return (x>=0 && x<gamemap.width && y>=0 && y<gamemap.height);
}

function pt(x,y){
	return {x:x,y:y};
}

function dx(a,b){
	return b.x-a.x;
}

function dy(a,b){
	return b.y-a.y;
}

function abs(x){return Math.abs(x);}

function adjacent(a,b){
	return abs(dx(a,b))+abs(dy(a,b))==1;
}

function contains(p,type){
	var pcs=gamemap.pieces(p.x,p.y);
	for(var i in pcs)
		if(pcs[i].type==type)return true;
	return false;
}

function ofType(p,type){
	var a=[];
	var pcs=gamemap.pieces(p.x,p.y);
	for(var i in pcs)
		if(pcs[i].type==type)a.push(pcs[i]);
	return a;
}
/////////////////////////////////////////////

gamemap.onclick=function(x,y){
	if(ignoreClicks)return;
	if(!adjacent(rover,pt(x,y)))return;
	if(wallP(pt(x,y)))return;
	if(status.fuel<1){
		print('Not enough fuel! Use a gem to make more fuel.');
		return;
	}
	
	rover.move(x,y);
	
	status.fuel--;
	updateSidebar();
	pickupGems();
}


function updateSidebar(){
	if(status.gems==1)
		sidebar[0]='1 gem in the rover';
	else
		sidebar[0]=status.gems+' gems in the rover';
	
	if(status.fuel==1)
		sidebar[1]='1 space of fuel remaining';
	else
		sidebar[1]=status.fuel+' spaces of fuel remaining';
}

function useGem(){
	if(status.gems<1){
		print('No gems available!');
		return;
	}
	status.gems--;
	status.fuel+=5;
	updateSidebar();
}

function pickupGems(){
	var gems=ofType(rover,'gem');
	status.gems+=gems.length;
	updateSidebar();
	for(i in gems)
		gamemap.remove(gems[i]);
}