function withSelect(map,name,selName,breakName,abortName){
	// map is the map
	// name is the name of the select fn (defaults to 'select')
	// selName is the name of the fn to call with the selected space (defaults to 'onselect')
	// breakName is the name of the fn to check whether to cancel the select (defaults to 'breakSelect')
	// abortName is the name of the fn to abort the select (defaults to abortSelect)
	
	name=name||'select';
	selName=selName||'onselect';
	breakName=breakName||'breakSelect';
	abortName=abortName||'abortSelect';
	
	var contains=function(list,coord){
		for(var i in list){
			if(list[i].x===coord.x && list[i].y===coord.y){
				return true;
			}
		}
		return false;
	}

	var pcs=null;
	var old=null;
	
	map[abortName]=function(){
		if(!pcs)return;
		for(var i in pcs){
			map.remove(pcs[i]);
		}
		map.onclick=old;
		pcs=null;
	}
	
	map[name]=function(spaces,sel,mark){
		pcs=[];
		old=this.onclick;
		var oldSel=this.onselect;
		
		mark=mark||function(){
			return new Piece({color:'green',shape:'outline'});
		};
		
		this[selName]=sel||oldSel;
		
		for(var c in spaces){
			var p=mark();
			map.place(p,spaces[c].x,spaces[c].y);
			pcs.push(p);
		}
		
		this.onclick=function(x,y,b){
			// first check for break
			if(typeof map[breakName] === 'function' && map[breakName](x,y,b)){
				if(typeof map[abortName] === 'function'){
					map[abortName]();
				}
			}else if(contains(spaces,{x:x,y:y})){ // then check for valid space
				for(var i in pcs){
					map.remove(pcs[i]);
				}
				if(typeof map[selName] === 'function'){
					map[selName](x,y,b);
				}
				map.onclick=old;
				pcs=null;
			}
		}		
	}
	
	return map;
}

function testSelect(){
	var a=[{x:0,y:0},{x:2,y:1}];
	var m=new Map(8,8);
	Window.map=m;
	withSelect(m);
	m.select(a,function(x,y){
		print(x+', '+y+' selected');
	});
}